static long ec_device_ioctl_xcmd(struct cros_ec_dev *ec, void __user *arg)
{
	long ret;
	struct cros_ec_command u_cmd;
	struct cros_ec_command *s_cmd;

	if (<@\textcolor{red}{copy\_from\_user(\&u\_cmd, arg, sizeof(u\_cmd))}@>)
		return -EFAULT;

	if ((u_cmd.outsize > EC_MAX_MSG_BYTES) ||
	    (u_cmd.insize > EC_MAX_MSG_BYTES))
		return -EINVAL;

	s_cmd = kmalloc(sizeof(*s_cmd) + max(u_cmd.outsize, u_cmd.insize),
			GFP_KERNEL);
	if (!s_cmd)
		return -ENOMEM;

	if (<@\textcolor{red}{copy\_from\_user(s\_cmd, arg, sizeof(\*s\_cmd) + u\_cmd.outsize)}@>) {
		ret = -EFAULT;
		goto exit;
	}

	s_cmd->command += ec->cmd_offset;
	ret = cros_ec_cmd_xfer(ec->ec_dev, s_cmd);
	/* Only copy data to userland if data was received. */
	if (ret < 0)
		goto exit;

	if (<@\textcolor{red}{copy\_to\_user(arg, s\_cmd, sizeof(*s\_cmd) + u\_cmd.insize)}@>)
		ret = -EFAULT;
exit:
	kfree(s_cmd);
	return ret;
}
